// Last edited on 2011-02-14 19:05:54 by stolfilocal
// Generic frame of a complex movie 
// (Two jumpers and a swimming microbe)

#include "nuvens.inc"

#include "bzpatch.inc"
#include "jumper.inc"
#include "jumper_take_01.inc"
#include "microbe.inc"
#include "microbe_take_01.inc"

#declare DY = 17.5;  // Y-step between bases
#declare DZ = +6.0;  // Height difference between odd and even bases

#local org = <0, -0.90*DY, 15>;
#local vel = <0, +2.00*DY, 0>;

#macro movie_frame(tt)

  union{
    object{ jumper_take_01(tt,DY,DZ) translate -5*x }
    object{ microbe_take_01(tt,2*DY) translate +5*x }
  }

  #declare cam_ctr = org + vel*tt;
  #declare cam_rad = 37.00;

#end

movie_frame(clock)
